#define etacs_cxx
#include "etacs.h"
#include <TH2.h>
#include <TH1.h>
#include <TStyle.h>
#include <TCanvas.h>
#include <Riostream.h>
#include <TKey.h>
#include <TFile.h>
//#include <fstream.h>

using namespace std;

int main(int argc,char **argv)
{
  	TH1F* MissingMass2;
	const Int_t num_bins = 50;
	const char *histoname = argv[3];

	if (argc > 3)
	{
		cerr << "about to open file\n";
		TFile* datafile = new TFile(argv[1],"read");
		if (datafile->IsZombie()) {
		  cerr << "\nError opening file " <<  argv[1] << endl << endl;
			exit(-1);
		} else cerr << "opening file...\n";
		TFile outfile(argv[2],"update");

		TKey *key = outfile.Findkey(&*histoname);
		if (key == 0)
		  MissingMass2 = new TH1F(argv[3], "Missing Mass Squared;GeV^2;counts", num_bins, 0, 3);
		else MissingMass2 = (TH1F*)outfile.Get(argv[3]);

		TTree* datatree = (TTree*)datafile->Get("h9500");
		etacs* etacsobj = new etacs(datatree);
		etacsobj->Loop(MissingMass2);
		MissingMass2->Write("", TObject::kOverwrite);
		outfile.Close();
		datafile->Close();
		return 1;
	} else {
		cerr << "\nuseage:  etacs datafile outfile histoname\n\n";
		exit(-1);
	}
}

Int_t etacs::Cut(Int_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.

		if (abs(hsdelta)<9 && ssdelta>-15 && ssdelta<25 && cointime>-6.2 && cointime<-2.2 && hcer_npe<1.0 && scer_npe>0.5 && ssshtrk>0.7) return 1;
		else return -1;
}

//void etacs::Loop(hmsang,hmsmom,q2)
void etacs::Loop(TH1F* histo)
{
//   In a ROOT session, you can do:
//      Root > .L etacs.C
//      Root > etacs t
//      Root > t.GetEntry(12); // Fill t data members with entry number 12
//      Root > t.Show();       // Show values of entry 12
//      Root > t.Show(16);     // Read and show values of entry 16
//      Root > t.Loop();       // Loop on all entries
//
//     This is the loop skeleton where:
//    jentry is the global entry number in the chain
//    ientry is the entry number in the current Tree
//  Note that the argument to GetEntry must be:
//    jentry for TChain:datatree:GetEntry
//    ientry for TTree::GetEntry and TBranch::GetEntry
//
//       To read only selected branches, Insert statements like:
// METHOD1:
//    fChain->SetBranchStatus("*",0);  // disable all branches
//    fChain->SetBranchStatus("branchname",1);  // activate branchname
// METHOD2: replace line
//    fChain->GetEntry(jentry);       //read all brancheshmsang,hmsmom,q2
//by  b_branchname->GetEntry(ientry); //read only this branch
   if (fChain == 0) return;

   Int_t nentries = Int_t(fChain->GetEntriesFast());

	//TH1F *MissingMass2 = new TH1F("MissingMass2", "Missing Mass Squared;GeV^2;counts", num_bins, 0, 3);

   Int_t nbytes = 0, nb = 0;
   for (Int_t jentry=0; jentry<nentries;jentry++) {
      Int_t ientry = LoadTree(jentry);
      if (ientry < 0) break;
      nb = fChain->GetEntry(jentry);   nbytes += nb;
      if (Cut(ientry) < 0) continue;

	cerr << "!";
	histo->Fill(mmass2);

   }
}
